%{!?_licensedir:%global license %%doc}
%define debug_package %{nil}

Name: OTPClient
Version: 4.0.2
Release: 1%{?dist}
Summary: C library that generates TOTP and HOTP according to RFC-6238
License: ASL 2.0
URL: https://github.com/paolostivanin/%{name}
Source0: %{url}/archive/refs/tags/v%{version}.tar.gz

BuildRequires: gcc gcc-c++ cmake3
BuildRequires: gtk3-devel >= 3.22
BuildRequires: glib2-devel >= 2.50
BuildRequires: jansson-devel >= 2.6.0
BuildRequires: libgcrypt-devel >= 1.6.0
BuildRequires: libzip-devel >= 1.0.0
BuildRequires: libpng-devel >= 1.2.0
BuildRequires: libcotp-devel >= 3.0.0
BuildRequires: zbar-devel >= 0.20
BuildRequires: protobuf-devel >= 3.6.0
BuildRequires: protobuf-c-devel >= 1.3.0
BuildRequires: libuuid-devel >= 2.34
BuildRequires: libsecret-devel >= 0.20
BuildRequires: qrencode-devel >= 4.0.2


%description
Highly secure and easy to use GTK+ software for two-factor authentication that
supports both Time-based One-time Passwords (TOTP) and HMAC-Based One-Time
Passwords (HOTP).

* support both TOTP and HOTP
* support setting custom digits (between 4 and 10 inclusive)
* support setting a custom period (between 10 and 120 seconds inclusive)
* support SHA1, SHA256 and SHA512 algorithms
* support for Steam codes (please read THIS PAGE)
* import encrypted Authenticator Plus backup
* import and export encrypted and/or plain andOTP backup
* import and export plain FreeOTPPlus backup (key URI format only)
* import and export plain Aegis backup (plain json only)
* local database is encrypted using AES256-GCM
  * key is derived using PBKDF2 with SHA512 and 100k iterations
  * decrypted file is never saved (and hopefully never swapped) to disk.
    While the app is running, the decrypted content resides in a "secure memory"
    buffer allocated by Gcrypt


%prep
%autosetup


%build
%{cmake3} .
%if 0%{?fedora} >= 33
%{cmake_build}
%else
make %{?_smp_mflags}
%endif


%install
[ '%{buildroot}' != '/' ] && rm -rf %{buildroot}
%if 0%{?fedora} >= 33
%{cmake_install}
%else
%make_install
%endif


%files
%license LICENSE
%doc README.md
%{_bindir}/otpclient
%{_bindir}/otpclient-cli
%{_datadir}/icons/hicolor/*/apps/*
%{_datadir}/metainfo/*.appdata.xml
%{_datadir}/applications/*.desktop
%dir %{_datadir}/otpclient
%{_datadir}/otpclient/*
%{_mandir}/man1/otpclient-cli.1*
%{_mandir}/man1/otpclient.1*
